package praktikum05;

import java.util.Random;

public class SnakeBot extends Bot {

    private int wagonsCollected = 0;
    int countMoves = 1;
   // private boolean damaged = false;

    public static void main(String[] args) {
        SnakeBot snakeBot = new SnakeBot(args);
        snakeBot.run();
    }

    protected SnakeBot(String[] args) {
        super(args);
    }

    @Override
    protected char nextMove(View view) throws Exception {
        /*if (damaged) {
            return 'q'; // Wenn der Rover beschädigt ist, stoppe die Bewegung
        }*/

        if (view.data.charAt(7) == '*') {
            outWalkWagon(view);
        } else if (view.data.indexOf('@') > -1) {
            return goToRock(view);
        } else {
            return findRock(view);
        }
        return '^';
    }

    protected char findRock(View view) {
        Random random = new Random();
        int randomDirection = random.nextInt(2);


        if (countMoves <= 10) {
            countMoves ++;
            return '^';
        } else if (countMoves > 10) {
            switch (randomDirection) {
                case 1:
                    countMoves = 0;
                    return '>'; // Rechtsdrehung
                case 2:
                    countMoves = 0;
                    return '<'; // Linksdrehung
            }
        }
        return '<';
    }

    protected char goToRock(View view) {
        int positionRock = view.data.indexOf('@');
        int positionRover = view.data.indexOf('A');
        if (positionRover / 5 != positionRock / 5) {
            if (positionRover / 5 > positionRock / 5) {
                if (view.data.charAt(7) == '*') {
                    return outWalkWagon(view);
                } else {
                    return '^';
                }
            } else if (positionRover / 5 < positionRock / 5) {
                if (view.data.charAt(17) == '*') {
                    return outWalkWagon(view);
                } else {
                    return 'v';
                }
            }
        }
        if (positionRover % 5 != positionRock % 5) {
            if (positionRover % 5 > positionRock % 5) {
                return '<';
            } else if (positionRover % 5 < positionRock % 5) {
                return '>';
            }
            return 0;
        }
        return 0;
    }

    protected char outWalkWagon(View view) {
        return '<';
    }

    /*protected char collectSample(View view) {
        int positionSample = view.data.indexOf('*');
        int positionRover = view.data.indexOf('A');

        // Überprüfen, ob die Gesteinsprobe im selben Feld ist
        if (positionRover == positionSample) {
            wagonsCollected++;
            if (wagonsCollected > 1) {
                damaged = true; // Der Rover wird beschädigt, wenn er in mehr als einen Wagen fährt
            }
            return 'C'; // Aufsammeln der Gesteinsprobe und Hinzufügen eines Wagens
        }

        // Ansonsten zufällig bewegen
        return findRock(view);
    }*/
}

